
#include "fccdb.h"
#include <cassert>
#include <cstring>

int main(int argc, char* argv[])
{
  {
    std::ifstream f1("facility.dat");
    
    if (argc == 1) {
      while (f1) {
	Facility d(f1);
	d.dump();
      }
    }else if (strcmp(argv[1], "-e") == 0) {
      while (f1) {
	Facility fac(f1);
	if (fac.fac_service == "FM" && fac.fac_country == "US" && fac.fac_type == "ED") {
	  std::cout << fac.fac_callsign << ' ' << fac.facility_id << ' ' << fac.fac_status <<'\n';
	  std::ifstream f2("fm_eng_data.dat");
	  while (f2) {
	    Fm_Eng_Data ed(f2);
	    if (fac.facility_id == ed.facility_id) {
	      if (ed.antenna_id != "") {
		std::ifstream f3("ant_pattern.dat");
		while (f3) {
		  Ant_Pattern ap(f3);
		  if (ed.antenna_id == ap.antenna_id) {
		    ap.dump(3., ed.fm_dom_status);
		  }else{
		  }
		}		  
	      }else{
		//std::cout << "non-directional\n";
	      }
	      break;
	    }else{
	    }
	  }
	  //fac.dump();
	}else{
	}
      }
    }else{
      while (f1) {
	Facility fac(f1);
	if ((argv[1] == fac.facility_id) || (fac.fac_callsign.compare(0, strlen(argv[1]), argv[1]) == 0)) {
	  std::cout << fac.fac_callsign << '\n';
	  std::ifstream f2("fm_eng_data.dat");
	  while (f2) {
	    Fm_Eng_Data ed(f2);
	    if (fac.facility_id == ed.facility_id) {
	      ed.dump();
	      if (ed.antenna_id != "") {
		std::ifstream f3("ant_pattern.dat");
		while (f3) {
		  Ant_Pattern ap(f3);
		  if (ed.antenna_id == ap.antenna_id) {
		    ap.dump(-1, ed.fm_dom_status);
		  }else{
		  }
		}		  
	      }else{
		//std::cout << "non-directional\n";
	      }
	    }else{
	    }
	  }
	  fac.dump();
	}else{
	}
      }
    }
  }
  return 0;
}
