// FCC database access -*- C++ -*-

#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <cmath>

const double NOT_INPUT = -2.23472e293;

double to_double(std::string s)
{
  std::istringstream is(s);
  double x = NOT_INPUT;
  is >> x;
  return x;
}

class Ant_Pattern {
public:
  std::string antenna_id;
  std::string azimuth;
  std::string field_value;
  std::string additional_az_num;
  std::string last_change_date;
public: 
  Ant_Pattern(std::istream& in) {
    std::string buffer;
    getline(in, buffer);
    std::istringstream is(buffer);
    getline(is, antenna_id, '|');
    getline(is, azimuth, '|');
    getline(is, field_value, '|');
    getline(is, additional_az_num, '|');
    getline(is, last_change_date, '|');
  }
  void dump(double print_diff, std::string& tail) {
    static std::string save_id = "";
    static double save_db = 0;
    double db = 20*log10(to_double(field_value));
    if (save_id != antenna_id) {
      save_db = db;
      save_id = antenna_id;
    }else{
    }
    double diff = std::abs(save_db - db);
    save_db = db;
#if 1
    if (diff > print_diff) {
      std::cout.setf(std::ios_base::fixed, std::ios_base::floatfield);
      std::cout.precision(2);
      std::cout << antenna_id << '\t' << azimuth << '\t' << field_value << '\t' 
		<< db << '\t' << diff << '\t' << tail << '\n';
    }      
#else
    std::string is_too_much = (diff > print_diff) ? "*******" : "";
    std::cout.setf(std::ios_base::fixed, std::ios_base::floatfield);
    std::cout.precision(2);
    std::cout << antenna_id << '\t' << azimuth << '\t' << field_value << '\t' 
	      << db << '\t' << diff << '\t' << is_too_much << '\n';
    //	      << additional_az_num << '\t' << last_change_date << '\n';
#endif
  }
};
